#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <dirent.h>

static void
print(const char *const msg, const struct stat *const s)
{
  fprintf(stderr, "dev %s: %X (%d/%d)\n", msg, s->st_dev
	  , major(s->st_dev)
	  , minor(s->st_dev));
}

int main(int argc, char *argv[])
{
  struct stat s;
  struct stat s_direct;
  int fd;
  char *filename1 = NULL;

  if (argc < 2) {
    fprintf(stderr, "Usage: filename\n");
    exit(1);
  }

  filename1 = argv[1];

  if (stat(filename1, &s_direct) == -1) {
    perror("stat");
    exit(2);
  }
  print("just stat", &s_direct);

  fd = open(filename1, O_RDONLY);
  if (fd == -1) {
    perror("open");
    exit(2);
  }

  if (fstat(fd, &s) == -1) {
    perror("fstat");
    exit(2);
  }
  print("using fstat", &s);

#if 0

  DIR *dir;
  dir = opendir(filename1);
  if (dir == NULL) {
    perror("opendir");
    exit(2);
  }

  if (fstat(dirfd(dir), &s) == -1) {
    perror("fstat");
    exit(2);
  }
  fprintf(stderr, "dev: %d\n", s.st_dev);

  if (stat("/mnt/tmp/X11", &s) == -1) {
    perror("stat");
    exit(2);
  }
  fprintf(stderr, "dev: %d\n", s.st_dev);
#endif

  return 0;
}

